local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Livestock3.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepYard.Part.001", "PREFAB_LIVESTOCKFARM_SHEEPYARD1")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepYard.Part.002", "PREFAB_LIVESTOCKFARM_SHEEPYARD2")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepYard.Part.003", "PREFAB_LIVESTOCKFARM_SHEEPYARD3")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepYard.Part.004", "PREFAB_LIVESTOCKFARM_SHEEPYARD4")

mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepPen.Part.001", "PREFAB_LIVESTOCKFARM_SHEEPPEN1")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepPen.Part.002", "PREFAB_LIVESTOCKFARM_SHEEPPEN2")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepPen.Part.003", "PREFAB_LIVESTOCKFARM_SHEEPPEN3")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepPen.Part.004", "PREFAB_LIVESTOCKFARM_SHEEPPEN4")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepPen.Part.005", "PREFAB_LIVESTOCKFARM_SHEEPPEN5")
mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepPen.Part.006", "PREFAB_LIVESTOCKFARM_SHEEPPEN6")

-- mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepPasture.Part.001", "PREFAB_LIVESTOCKFARM_SHEEPPASTURE1")

-- for i=1, 5, 1 do
--     mod:registerAssetId("models/Livestock3.fbx/Prefab/Pasture.Part." .. string.sub("000" .. i, -3), "PREFAB_LIVESTOCKFARM_SHEEPPASTUREPLANT" .. i)
--     mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/Pasture.Part." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })
-- end

mod:registerAssetId("models/Livestock3.fbx/Prefab/SheepSpawner", "PREFAB_LIVESTOCKFARM_SHEEPSPAWNER")



-- Transparency -------------------------------------------------------------------------------------
mod:registerAssetId("models/Livestock3.fbx/Materials/Material.Hay3", "MATERIAL_LIVESTOCKFARM_SHEEP_HAY3")
mod:override({
    Id = "MATERIAL_LIVESTOCKFARM_SHEEP_HAY3",
    HasAlphaTest = true
})

-- mod:registerAssetId("models/Livestock3.fbx/Materials/Material.Grass1", "MATERIAL_LIVESTOCKFARM_SHEEP_GRASS1")
-- mod:override({
--     Id = "MATERIAL_LIVESTOCKFARM_SHEEP_GRASS1",
--     HasAlphaTest = true
-- })

-- mod:registerAssetId("models/Livestock3.fbx/Materials/Material.Flowers1", "MATERIAL_LIVESTOCKFARM_SHEEP_FLOWERS1")
-- mod:override({
--     Id = "MATERIAL_LIVESTOCKFARM_SHEEP_FLOWERS1",
--     HasAlphaTest = true
-- })



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.001/Hay.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.001/Hay.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.001/Trough.001", {DataType = "COMP_GROUNDED"})
for i=1, 18, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.001/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.002/Hay.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.002/Hay.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.002/Hay.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.002/Trough.002", {DataType = "COMP_GROUNDED"})
for i=51, 68, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.002/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.003/Hay.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.003/Hay.007", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.003/Hay.008", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.003/Trough.003", {DataType = "COMP_GROUNDED"})
for i=69, 86, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.003/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.004/Hay.010", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.004/Trough.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.004/Trough.005", {DataType = "COMP_GROUNDED"})
for i=87, 104, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepYard.Part.004/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.001/Bucket.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.001/Bucket.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.001/Bucket.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.001/Hook.001", {DataType = "COMP_GROUNDED"})
for i=19, 26, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.001/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.002/Bucket.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.002/Bucket.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.002/Hook.002", {DataType = "COMP_GROUNDED"})
for i=27, 34, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.002/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.003/Bucket.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.003/Bucket.007", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.003/Bench.003", {DataType = "COMP_GROUNDED"})
for i=35, 42, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.003/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.004/Bucket.008", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.004/Bench.004", {DataType = "COMP_GROUNDED"})
for i=43, 50, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.004/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=105, 112, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.005/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=113, 120, 1 do
	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.006/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

-- for i=1, 120, 1 do
-- 	mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPasture.Part.001/Attach_Minor." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
-- end



-- Resource Generator -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.001/TallowGenerator.001", { DataType = "COMP_LIVESTOCKFARM_RESOURCEGENERATOR", ResourceGenerator = "BUILDING_FUNCTION_LIVESTOCKFARM_TALLOW", })
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepPen.Part.002/TallowGenerator.002", { DataType = "COMP_LIVESTOCKFARM_RESOURCEGENERATOR", ResourceGenerator = "BUILDING_FUNCTION_LIVESTOCKFARM_TALLOW", })



-- Building Part: Sheep Yard -------------------------------------------------------------------------------------
local poly1a = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -4.00, -4.00 },
	{ -4.00, 4.00 },
	{ 4.00, 4.00 },
	{ 4.00, -4.00 },
	{ -4.00, -4.00 },
	{ -4.5, -7.0 },
	{ 4.5, -7.0 },
	{ 4.5, 4.5 },
	{ -4.5, 4.5 },
	{ -4.5, -7.0 },
}

local poly1b = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -2.50, -2.50 },
	{ -2.50, 2.50 },
	{ 2.50, 2.50 },
	{ 2.50, -2.50 },
	{ -2.50, -2.50 },
	{ -3.00, -3.00 },
	{ 3.00, -3.00 },
	{ 3.00, 3.00 },
	{ -3.00, 3.00 },
	{ -3.00, -3.00 },
}

local poly1c = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ 4.5, -7.0 },
	{ 4.5, 4.5 },
	{ -4.5, 4.5 },
	{ -4.5, -7.0 },
}

for i=1, 4, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPYARD" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPYARD" .. i .. "_NAME", 
        -- Category = "CORE", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_SHEEPYARD" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0.5, 4.4, -10 },
                OrientationOffset = -15.0,
                CameraPitchOffset = 25.0
            },
        },
    })

end

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPYARD",
	Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPYARD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_SHEEPYARD1",
			"BUILDING_PART_LIVESTOCKFARM_SHEEPYARD2",
			"BUILDING_PART_LIVESTOCKFARM_SHEEPYARD3",
			"BUILDING_PART_LIVESTOCKFARM_SHEEPYARD4",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0.5, 4.4, -10 },
            OrientationOffset = -15.0,
            CameraPitchOffset = 25.0
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly1a,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = poly1b,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = polygon.createRectangle( {10, 4}, {0.0, -5.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
            { 
                Polygon = polygon.createRectangle( {10, 10}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEPYARD",
    Cost = {
        BuildRightTaxes = { { Resource = "GOLD_COINS", Quantity = 5 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 20 },
            { Resource = "PLANK", Quantity = 10 },
            { Resource = "WOOD", Quantity = 1 },
        }
    },
    DesirabilityModifiers = { {
        Desirability = "DESIRABILITY_RESIDENTIAL",
        Type = "SUBSTRACT",
        Radius = 20.0,
        Value = 0.5
    } },
})



-- Building Part: Sheep Pen -------------------------------------------------------------------------------------
local poly2a = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -1.70, -1.70 },
	{ -1.70, 1.70 },
	{ 1.70, 1.70 },
	{ 1.70, -1.70 },
	{ -1.70, -1.70 },
	{ -2.20, -2.20 },
	{ 2.20, -2.20 },
	{ 2.20, 2.20 },
	{ -2.20, 2.20 },
	{ -2.20, -2.20 },
}

local poly2b = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -1.20, -1.20 },
	{ -1.20, 1.20 },
	{ 1.20, 1.20 },
	{ 1.20, -1.20 },
	{ -1.20, -1.20 },
	{ -1.70, -1.70 },
	{ 1.70, -1.70 },
	{ 1.70, 1.70 },
	{ -1.70, 1.70 },
	{ -1.70, -1.70 },
}

for i=1, 2, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SLAUGHTER" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SLAUGHTER_NAME", 
        -- Category = "CORE", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_SHEEPPEN" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0.0,
                CameraPitchOffset = 25.0
            },
        },
    })

end

for i=3, 4, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_MILK" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_MILK_NAME", 
        -- Category = "CORE", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_SHEEPPEN" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0.0,
                CameraPitchOffset = 25.0
            },
        },
    })

end

for i=5, 6, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SHEAR" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SHEAR_NAME", 
        -- Category = "CORE", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_SHEEPPEN" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0.0,
                CameraPitchOffset = 25.0
            },
        },
    })

end

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SLAUGHTER",
	Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SLAUGHTER_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SLAUGHTER1",
			"BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SLAUGHTER2",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly2a,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
                -- Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                -- Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            },
            { 
                Polygon = poly2b,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
                -- Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                -- Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            },
            { 
                Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_SLAUGHTER",
    Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 },
        },
    },
    DesirabilityModifiers = { {
        Desirability = "DESIRABILITY_RESIDENTIAL",
        Type = "SUBSTRACT",
        Radius = 20.0,
        Value = 0.5
    } },
})

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_MILK",
	Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_MILK_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_MILK3",
			"BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_MILK4",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly2a,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
                -- Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                -- Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            },
            { 
                Polygon = poly2b,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
                -- Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                -- Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            },
            { 
                Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_MILK",
    Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
        }
    },
})

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SHEAR",
	Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SHEAR_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SHEAR5",
			"BUILDING_PART_LIVESTOCKFARM_SHEEPPEN_SHEAR6",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly2a,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
                -- Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                -- Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            },
            { 
                Polygon = poly2b,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
                -- Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                -- Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            },
            { 
                Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_SHEAR",
    Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 },
        }
    },
})



-- Building Function: Sheep Yard -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEPYARD",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEPYARD_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_HERD", 
        Behavior = "BEHAVIOR_WORK"
	},
    InputInventoryCapacity = {
        { Resource = "WATER", Quantity = 50 },
        { Resource = "RESOURCE_HAY", Quantity = 20 },
    },
    ResourceListNeeded = {
        { Resource = "WATER", Quantity = 1 },
        { Resource = "RESOURCE_HAY", Quantity = 1 },
    },
    ResourceProduced = {
        { Resource = "RESOURCE_SHEEP", Quantity = 1 },
        { Resource = "RESOURCE_DUNG", Quantity = 1 },
    }
})



-- Building Function Assignable: Sheep -------------------------------------------------------------------------------------
-- mod:register({
--     DataType = "BUILDING_FUNCTION_ASSIGNABLE",
--     Id = "BUILDING_FUNCTION_ASSIGNABLE_LIVESTOCKFARM_SHEEP",
-- 	Name = "BUILDING_FUNCTION_ASSIGNABLE_LIVESTOCKFARM_SHEEP_NAME",
-- 	AuthorizedFunctionList = "FUNCTION_LIST_LIVESTOCKFARM_SHEEP"
-- })

-- mod:register({
--     DataType = "BUILDING_FUNCTION_LIST",
--     Id = "FUNCTION_LIST_LIVESTOCKFARM_SHEEP",
-- 	AssetFunctionList = {
-- 		"BUILDING_FUNCTION_LIVESTOCKFARM_MIX_SHEEP",
-- 		"BUILDING_FUNCTION_LIVESTOCKFARM_SLAUGHTER_SHEEP",
-- 		"BUILDING_FUNCTION_LIVESTOCKFARM_MILK_SHEEP",
-- 		"BUILDING_FUNCTION_LIVESTOCKFARM_SHEAR_SHEEP",
-- 	}
-- })


-- mod:register({
--     DataType = "BUILDING_FUNCTION_WORKPLACE",
--     Id = "BUILDING_FUNCTION_LIVESTOCKFARM_MIX_SHEEP",
--     Name = "BUILDING_FUNCTION_LIVESTOCKFARM_MIX_SHEEP_NAME",
--     WorkerCapacity = 1,
--     RelatedJob = { 
--         Job = "JOB_LIVESTOCKFARM_PROCESS", 
--         Behavior = "BEHAVIOR_WORK"
--     },
--     InputInventoryCapacity = {
-- 		{ Resource = "RESOURCE_SHEEP", Quantity = 4 }
-- 	},
--     ResourceListNeeded = {
-- 		{ Resource = "RESOURCE_SHEEP", Quantity = 4 }
-- 	},
--     ResourceProduced = {
-- 		{ Resource = "BV1_CARCASS", Quantity = 1 },
-- 		{ Resource = "MILK", Quantity = 2 },
-- 		{ Resource = "WOOL", Quantity = 2 },
-- 	},
-- })

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_SLAUGHTER",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_SLAUGHTER_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_PROCESS", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "BV1_CARCASS", Quantity = 1 },
	},
})

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_MILK",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_MILK_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_PROCESS", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "MILK", Quantity = 2 },
	},
})

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_SHEAR",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEP_SHEAR_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_PROCESS", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "WOOL", Quantity = 2 },
	},
})



-- Spawn animals in yard and pen -------------------------------------------------------------------------------------
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPYARD1", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 12 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPYARD2", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 12 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPYARD3", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 12 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPYARD4", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 12 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPPEN1", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 2 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPPEN2", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 2 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPPEN3", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 2 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPPEN4", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 2 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPPEN5", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 2 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPPEN6", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 2 } )



-- Building Part: Sheep Barn (repupose Sheep Farm) -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_SHEEP_FARM",
    IsHidden = true,
})

mod:override({
    Id = "BUILDING_PART_SHEEP_FARM",
    Name = "BUILDING_PART_LIVESTOCKFARM_SHEEPBARN_NAME",
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEPBARN",
})



-- Crop Field Element -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepSpawner", { DataType = "COMP_CROP_FIELD_ELEMENT" })



-- Plantable -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Livestock3.fbx/Prefab/SheepSpawner", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 0.5 })

mod:register({
    DataType = "PLANTABLE",
    Id = "PLANTABLE_LIVESTOCKFARM_SHEEPSPAWNER",
    Name = "PLANTABLE_LIVESTOCKFARM_SHEEPSPAWNER_NAME",
    PlantPrefab = "PREFAB_LIVESTOCKFARM_SHEEPSPAWNER",
    Icon = "ICON_SHEEP",
    MinimumScale = 0.85, -- min size at full growth
    MaximumScale = 1.15 -- max size at full growth
})



-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Livestock3.fbx/Prefab/SheepSpawner", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_SHEEP",
    IsReplenishable = false,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 2.00, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false,
    HasMaximumWorkstation = false
})



-- Zone -------------------------------------------------------------------------------------
mod:register({
    DataType = "ZONE",
    Id = "ZONE_LIVESTOCKFARM_SHEEP",
    Name = "ZONE_LIVESTOCKFARM_SHEEP_NAME",
    Description = "ZONE_LIVESTOCKFARM_SHEEP_NAME",
    Icon = "ICON_SHEEP",
    HoverIcon = "ICON_SHEEP",
    SelectionIcon = "ICON_SHEEP",
    Color = {1.00, 1.70, 0.60, 0.9}, -- RGB A = 
    DesirabilityLayerToShow = "DESIRABILITY_FERTILITY"
})



-- Farm Field Config -------------------------------------------------------------------------------------
mod:register({
    DataType = "FARM_FIELD_CONFIG",
    Id = "FARM_FIELD_CONFIG_LIVESTOCKFARM_SHEEP",
    ZoneType = "ZONE_LIVESTOCKFARM_SHEEP",
    PlantPrefab = "PREFAB_LIVESTOCKFARM_SHEEPSPAWNER",
    HasPlantingCycle = false,
    IsScaling = false,
    RowDistance = 7,
    ItemDistance = 7,
    RandomOrientation = {-180, 180},
    RandomPositionOffset = {0, 0},
    SourceMaterial = "MATERIAL_LIVESTOCKFARM_GRASS1",
    GrowingMaterial = "MATERIAL_LIVESTOCKFARM_GRASS1",
    HarvestedMaterial = "MATERIAL_LIVESTOCKFARM_GRASS1",
    GrowingTextureList = {
        "TEXTURE_LIVESTOCKFARM_BLANK",
    },
    HarvestingTextureList = {
        "TEXTURE_LIVESTOCKFARM_BLANK",
    },
    AlphaTestThreshold = 0.5
})



-- Sowing Setup -------------------------------------------------------------------------------------
mod:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = "AGENT_WORKSTATION_SETUP_LIVESTOCKFARM_SHEEP_SOWING",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        FemaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
        MaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD",
	},
})



-- Growing Setup -------------------------------------------------------------------------------------
mod:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = "AGENT_WORKSTATION_SETUP_LIVESTOCKFARM_SHEEP_GROWING",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        FemaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
        MaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD",
	},
})



-- Harvest Setup -------------------------------------------------------------------------------------
mod:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = "AGENT_WORKSTATION_SETUP_LIVESTOCKFARM_SHEEP_HARVEST",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        FemaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
        MaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD",
	},
})



-- Building Function: Sheep Fold (pasture) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_FARM",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEPBARN",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_SHEEPBARN_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_BARN", 
        Behavior = "BEHAVIOR_FARMER"
    },
    -- InputInventoryCapacity = {
	-- 	{ Resource = "WATER", Quantity = 5 },
	-- 	-- { Resource = "DUNG_RESOURCE", Quantity = 5 }
	-- },
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }, 
	},
	ResourceProduced = {
        { Resource = "RESOURCE_SHEEP", Quantity = 1 },
    },

    -- there is a max total cycle of 21 days so if you plan beyond that, it will be cut short
    -- SowingDurationPerc = {0, 7},
	-- GrowDuration = {7, 7},
	-- GrowWaitDuration = {7, 7},
	HarvestDuration = {0, 21},
	-- RestDuration = {18, 21},

    QuantityToHarvestPerStep = 1,
	HarvestStepsCount = 1,
	QuantityToPlantPerStep = 1,
	PlantingStepsCount = 1,
	ResourceValuePerGather = 1,

    CropFieldConfig = "FARM_FIELD_CONFIG_LIVESTOCKFARM_SHEEP",
    SowingSetup = "AGENT_WORKSTATION_SETUP_LIVESTOCKFARM_SHEEP_SOWING", 
    GrowingSetup = "AGENT_WORKSTATION_SETUP_LIVESTOCKFARM_SHEEP_GROWING", 
    HarvestSetup = "AGENT_WORKSTATION_SETUP_LIVESTOCKFARM_SHEEP_HARVEST"
})



-- Job: Barn -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_LIVESTOCKFARM_BARN",
	JobName = "JOB_LIVESTOCKFARM_BARN_NAME",
	JobDescription = "JOB_LIVESTOCKFARM_BARN_DESC",
	IsLockedByDefault = false,
    Hidden = true,
	DefaultBehavior = "BEHAVIOR_FARMER",
    ProductionDelay = 30, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        FemaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
        MaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD",
	},
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_BARN"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_BARN"
    }
})



-- Spawn sheep in pasture -------------------------------------------------------------------------------------
mod:registerPrefabComponent("PREFAB_LIVESTOCK_SHEEP", { DataType = "COMP_ENFORCE_RADIUS", Radius = 2 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCK_SHEEP", { DataType = "COMP_AGENT", BehaviorTree = "BEHAVIOR_RADIAL_CONFINED_AGENT", RoadPaintSpeed = 0 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_SHEEPSPAWNER", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_SHEEP", AnimalCount = 1 } )
